# Run BGPalerter behind a proxy
BGPalerter can be run in a production environment requiring to access external resources via an HTTP/HTTPS proxy.
To enable this setting, in `config.yml` uncomment the following line and set the correct proxy URL:

```yaml
httpProxy: http://username:password@proxy.example.org:8080
```
This will enable the proxy globally on all HTTP/HTTPS/WebSocket traffic generated by BGPalerter. 

## Bypass proxy for specific BGPalerter modules

While the global configuration will send all requests to the proxy, you can specify which modules are able to bypass the proxy.
This is useful for example if you want to not proxy requests to internal apps or networks. 
This can be set per module (i.e., reporter/connector/monitor) by adding the `noProxy: true` parameter to the desired module(s) in `config.yml`.
For instance, the configuration below allows you to bypass your proxy server for your traffic towards an Alerta dashboard.


```yaml
 - file: reportAlerta
   channels:
     - hijack
     - newprefix
     - visibility
     - path
     - misconfiguration
     - rpki
   params:
     noProxy: true
     severity:
       hijack: critical
       newprefix: informational
       visibility: debug
       path: trace
```